#!/bin/bash

set -x

TOP_DIR=$(cd $(dirname "$0") && pwd)

function build_ovn_service() {
    set -e
    running_pcmk_img=$(docker images | grep "rhosp13/openstack-ovn-${1}" | grep pcmklatest | awk {'print $3'})
    : ${IMAGE_TAG=$(docker images | grep "${running_pcmk_img}" | grep -v pcmklatest | awk 'NR==1{print $2}')}


    rm -rf /tmp/hotfix
    mkdir /tmp/hotfix

    cp *rpm /tmp/hotfix
    if [ $1 == "northd" ]; then
        rm -f /tmp/hotfix/libevent*rpm
    fi
    cp hotfix.yaml $PWD/ansible-role-tripleo-modify-image
    cd $PWD/ansible-role-tripleo-modify-image
    ansible-playbook -e "image_tag=$IMAGE_TAG service=$1" hotfix.yaml
    cd $TOP_DIR
    rm -rf /tmp/hotfix
    set +e
}

git clone https://github.com/openstack/ansible-role-tripleo-modify-image
mkdir ansible-role-tripleo-modify-image/roles
ln -s $PWD/ansible-role-tripleo-modify-image $PWD/ansible-role-tripleo-modify-image/roles/tripleo-modify-image
docker_image_prefix=`docker images | cut -f1 -d/ | sort | uniq | head -1`
if [[ -z "${docker_image_prefix}" ]]; then
    docker_image_prefix="registry.access.redhat.com"
fi

sed -i -e "s/source_image:.*/source_image: ${docker_image_prefix}\/rhosp13\/openstack-ovn-{{ service }}:{{ image_tag }}/" hotfix.yaml

if [ "$(docker ps | grep "ovn-northd" | awk '{print $1}')" != "" ]; then build_ovn_service northd ; fi
